.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm

.data?
buffer	dd 100 dup (?)

.data
My64a	QWORD	12345678901234567890
My64b	QWORD	10987654321098765432
My64c	QWORD	1234567890
My32c	DWORD	1234567890

.code
start:
	LoopCount = 1000000
	invoke Sleep, 500
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov edx, offset My64a
		push offset buffer
		push [edx+4]
		push [edx]
		call U64ToStr
	counter_end
	print ustr$(eax)," cycles for U64ToStr", 9
	print offset buffer, 13, 10

	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov edx, offset My64b
		push offset buffer
		push [edx+4]
		push [edx]
		call U64ToStr
	counter_end
	print ustr$(eax)," cycles for U64ToStr", 9
	print offset buffer, 13, 10

	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov edx, offset My64c
		push offset buffer
		push [edx+4]
		push [edx]
		call U64ToStr
	counter_end
	print ustr$(eax)," cycles for U64ToStr", 9
	print offset buffer, 13, 10

	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov edx, offset My32c
		push offset buffer
		push [edx]
		call dwtoa
	counter_end
	print ustr$(eax)," cycles for dwtoa", 9
	print offset buffer, 13, 10
	exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

U64ToStr proc QwVal:QWORD, pszString:DWORD
	push ebp
	push esi
	push edi
	push ebx
	mov eax, [esp+3*4][4*4]
	push eax	; variable - buffer pointer
	; QwVal conversion loop
	jmp @@U64Cvt
	@@:
	mov eax, 0CCCCCCCDh	; = b0
	mul esi	; get a0*b0 = d1:d0
	mov ebp, eax	; d1
	mov eax, 0CCCCCCCDh	; = b0
	mul edi	; get a1*b0 = e1:e0
	mov ecx, eax	; e0
	mov ebx, edx	; e1
	mov eax, 0CCCCCCCCh	; =b1
	mul esi	; get a0*b1 = f1:f0
	mov esi, eax	; f0
	push edx	; f1
	mov eax, 0CCCCCCCCh	; =b1
	mul edi	; get a1*b1 = g1:g0
	add ebp, ecx	; +e0
	pop edi	; =f1
	adc eax, 0
	add ebp, esi	; +f0
	adc eax, 0
	add eax, edi	; +f1
	adc edx, 0
	add eax, ebx	; +e1
	adc edx, 0
	shrd eax, edx, 3
	shr edx, 3	; ------ quotient in edx::eax
	mov esi, [esp+1*4][4*4][4]	; a0
	mov edi, [esp+2*4][4*4][4]	; a1
	mov [esp+1*4][4*4][4], eax	; store quotient
	mov [esp+2*4][4*4][4], edx	; 
		; multiply by 10
	add eax, eax	; 
	adc edx, edx	; i*=2
	mov ecx, eax	; 
	mov ebx, edx	; j=i
	add eax, eax	; 
	adc edx, edx	; 
	add eax, eax	; 
	adc edx, edx	; i*=4
	add eax, ecx	; 
	adc edx, ebx	; i+=j
		; substract to get remainder
	sub esi, eax
	sbb edi, edx
		; add '0' and write to buffer
	mov ebp, [esp]	; buff
	lea eax, [esi+'0']
	mov [ebp], al
	add ebp, 1
	mov [esp], ebp

	@@U64Cvt:
	mov esi, [esp+1*4][4*4][4]	; a0
	mov edi, [esp+2*4][4*4][4]	; a1
	test edi, edi
	jnz @B
		; 	; we are here if HI-DWORD is 0
	mov ebp, [esp]	; get buffer pointer
	mov eax, esi
	mov ebx, esi
		; Lower Dword conversion loop start
	@@: mov edx, 0CCCCCCCDh
	mul edx
	shr edx, 3
	lea ecx, [edx*4+edx]
	lea ecx, [ecx+ecx-'0']
	sub ebx, ecx
	mov eax, edx
	mov [ebp], bl
	mov ebx, edx
	add ebp, 1
	test eax, eax
	jnz @B
		; Calculate output string length and reverse it
	mov edi, [esp+3*4][4*4][4]
	mov ecx, ebp
	sub ecx, edi
	mov [ebp], al
	mov [esp], ecx
		; reverse buffer digits
	@@: dec ebp
	mov bl, [edi]
	mov cl, [ebp]
	mov [ebp], bl
	mov [edi], cl
	inc edi
	cmp edi, ebp
	jb @B
		; string length in eax
	pop eax
	pop ebx
	pop edi
	pop esi
	pop ebp
	ret 3*4
U64ToStr endp

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

end start

OPT_Wait	1
OPT_Tmp2Asm	1
OPT_Linker	polink
Dummy
